/* Author:  John Romain
 * Creation Date:  January 2, 2016
 * Purpose:  Captivate JavaScript Functions
 * Requirements:  Nil
 * Modified:
 */
/*
	Module Variables
*/

var facilitatorID;
var facilaitatorPresenting = true;
var lmsExerciseCompleteState = ["Slide Number Not Set", "false", "false", "false", "false", "false", "false", "false", "false", "false", "false", "false"];
var moduleLoaded = false;
var navigationLock = "false";
var navigationGRPButtons;


/*
	Module initialization
*/

var infinityModuleReady = function(evtObj) {
	moduleLoaded = true;
	console.log("The module " + window.cpAPIInterface.getVariableValue('cpInfoCourseName') + " has loaded");
}
window.addEventListener("moduleReadyEvent", infinityModuleReady);


/*
	Module navigation
*/

function slideInit() {

	console.log("slideInit Running!!!");
	navigationGRPButtons = ["_next_btn", "_previous_btn"];
	slideName = window.cpAPIInterface.getVariableValue('cpInfoCurrentSlideLabel');
	navigationGRPButtons = ["_next_btn", "_previous_btn"];
	unlockExerciseNum = Number(window.cpAPIInterface.getVariableValue('cpexerciseNumber'));

	// Lock the navigation where required.
	if (window.cpAPIInterface.getVariableValue('cpnavigationLock') == "true") {
		if (lmsExerciseCompleteState[unlockExerciseNum] == "false") {
			console.log("Locking navigation from slide init exercise complete for this slide is: " + lmsExerciseCompleteState[unlockExerciseNum]);
			lockNavigation(navigationGRPButtons);
			console.log("The slide has been locked by the slide init navigation function. Locking down navigation buttons: " + window.cpAPIInterface.getVariableValue('cpInfoProjectName'))
		}
	}
};

/*
	Open New Page with Alert
*/

var openNewPage = function(urlToOpen, lang) {
	switch (lang) {
		case "en":
			if (confirm("The selected link will open in a NEW window.\nTo continue with the module please RETURN to THIS window. Select the “OK” button to continue\nor the “Cancel” button to close this alert.") == true) {
				window.open(urlToOpen, "_blank");
			} else {

			};
			break;
		case "fr":
			if (confirm("Le lien que vous avez sélectionné s'ouvrira dans une nouvelle fenêtre. Sélectionnez le bouton « OK »  pour continuer.") == true) {
				window.open(urlToOpen, "_blank");
			} else {

			};
			break;
		default:

			break;
	}
}

function confirmNameEmail(lang){
	var enteredEmail = window.cpAPIInterface.getVariableValue('varUsereMail');
	var enteredName = window.cpAPIInterface.getVariableValue('varFirstName')+" "+window.cpAPIInterface.getVariableValue('varLastName');;
	if (enteredEmail == "yourname@domain.com"){
		enteredEmail = "No email Address Provided"
	}
	
	switch (lang){
	case "en":
		if (confirm("The name on your certificate will be:\n"+enteredName+"\n\nThe email address the certificate will be sent to is:\n"+enteredEmail+".\n\nSelect the “OK” button to if this is correct or the “Cancel” button to correct the information.") == true) {
			window.cp.hide("firstName_teb");
			window.cp.hide("lastName_teb");
			window.cpAPIInterface.next();
		} else {
			
		}
		break ;
	case "fr" :
		if (confirm("Le nom sur votre certificat apparaîtra comme suit :\n"+enteredName+"\n\nL’adresse électronique à laquelle le certificat sera envoyé est la suivante :\n"+enteredEmail+".\n\nSélectionnez le bouton «OK» si ces renseignements sont exacts ou le bouton «Annuler» pour les corriger.") == true) {
			window.cp.hide("firstName_teb");
			window.cp.hide("lastName_teb");
			window.cpAPIInterface.next();
		} else {
			
		}
		break;
	default:
		
		break;
		
	}
	
}

	function getCompletionCertificate(version, lang) {
		
		if (window.cpAPIInterface.getVariableValue('certificatePrinted') == "1"){
			switch (lang){
			case "en":
				if (confirm("You have already submitted a certificate request. Do you wish to open another certificate page and receive an additional e-mail?") == true) {
					mol.getCertificate();
					window.ga('send', 'event', version, 'certificateReceived', 'user clicked on certificate button-multiple', 1);
				} else {

				};
				break;
			case "fr":
				if (confirm("Vous avez déjà soumis une demande de certificat. Voulez-vous obtenir un autre certificat et recevoir un courriel additionnel?") == true) {
					mol.getCertificate();
					window.ga('send', 'event', version, 'certificateReceived', 'user clicked on certificate button', 1);
				} else {

				};
				break;
			default:

				break;
			}
		} else {
			switch (lang){
			case "en":
				if (confirm("If you provided the email address, the certificate of completion will be sent to you. If you do not see the message in your inbox, please check your spam/junk folder.") == true) {
					mol.getCertificate();
					window.ga('send', 'event', version, 'certificateReceived', 'user clicked on certificate button', 1);
				} else {

				};
				break;
			case "fr":
				if (confirm("Si vous avez fourni une adresse électronique, le certificat d’achèvement vous sera envoyé. Si vous ne voyez pas ce message dans votre boîte de réception, veuillez vérifier votre chemise de pourriels.") == true) {
					mol.getCertificate();
					window.ga('send', 'event', version, 'certificateReceived', 'user clicked on certificate button', 1);
				} else {

				};
				break;
			default:

				break;
			}
		}		
	};

function lockNavigation(itemsToLock) {
	contentArray = itemsToLock
	for (i = 0; i < contentArray.length; i++) {
		alphaChange("down", slideName + contentArray[i]);
		window.cp.disable(slideName + contentArray[i]);
		console.log("The items to lock are: " + itemsToLock);
	}
	navigationLock = "true";

	switch (window.cpAPIInterface.getVariableValue('cpexerciseType')) {
		case "video":
			alert01Message = "Slide navigation is locked. Please view the video on this slide prior to moving to the next slide."
			break;
		case "slide":
			alert01Message = "Slide navigation is locked. Please complete the exercise on this slide prior to moving to the next slide."
			break;
		default:
			alert01Message = "Slide navigation is locked. Please complete the exercise on this slide."
			break;
	};
};

function unLockNavigation(itemsToUnLock) {
	contentArray = itemsToUnLock;
	for (i = 0; i < contentArray.length; i++) {
		alphaChange("up", slideName + contentArray[i]);
		window.cp.enable(slideName + contentArray[i]);
	}
	window.cpAPIInterface.setVariableValue('cpnavigationLock', 'false');
	navigationLock = "false";
	lmsExerciseCompleteState[unlockExerciseNum] = "true"
	console.log("The lms data is currently: " + lmsExerciseCompleteState + ". The navigation lock is: " + navigationLock);
};


function videoCompleted() {
	console.log("The video is finished!!!");
	unLockNavigation(navigationGRPButtons);
}



/*=========================================================
Settings Manipulation
===========================================================*/

function alphaChange(direction, target) {
	var thisElement = document.getElementById(target + "c");
	switch (direction) {
		case "up":
			thisElement.style.opacity = 1;
			break;
		case "down":
			thisElement.style.opacity = .5;
			break;
		default:

			break;
	}
};


function hideItems(itemsToShowHide) {
	var itemsHidden = itemsToShowHide.split(",");
	for (i = 0; i < itemsHidden.length; i++) {
		window.cp.hide(slideName + itemsHidden[i]);
	}
};

function showItems(itemsToShowHide) {
	var itemsShown = itemsToShowHide.split(",");
	console.log("Running show items!!!" + itemsShown);
	for (i = 0; i < itemsShown.length; i++) {
		window.cp.hide(slideName + itemsShown[i]);
		console.log(slideName + itemsShown[i]);
	}
};

/*
=========================================================
Accessibility Enhancements
=========================================================
*/

function restoreFocusWhenCurrentFocusIsLost() {
  if (!jQuery) {
    console.log('jQuery does not appear to be loaded');
  }
  var $ = jQuery;
  // add support for :focusable and :tabbable selectors from jQueryUI
  function visible(element) {
    return $.expr.filters.visible(element) &&
      !$(element).parents().andSelf().filter(function() {
        return $.css(this, "visibility") === "hidden";
      }).length;
  };
 
  function focusable(element, isTabIndexNotNaN) {
    var map, mapName, img,
      nodeName = element.nodeName.toLowerCase();
    if ("area" === nodeName) {
      map = element.parentNode;
      mapName = map.name;
      if (!element.href || !mapName || map.nodeName.toLowerCase() !== "map") {
        return false;
      }
      img = $("img[usemap='#" + mapName + "']")[0];
      return !!img && visible(img);
    }
    return (/^(input|select|textarea|button|object)$/.test(nodeName) ?
        !element.disabled :
        "a" === nodeName ?
        element.href || isTabIndexNotNaN :
        isTabIndexNotNaN) &&
      visible(element);
  };
 
  $.extend($.expr[":"], {
    data: $.expr.createPseudo ?
      $.expr.createPseudo(function(dataName) {
        return function(elem) {
          return !!$.data(elem, dataName);
        };
      }) :
      // support: jQuery <1.8
      function(elem, i, match) {
        return !!$.data(elem, match[3]);
      },
 
    focusable: function(element) {
      return focusable(element, !isNaN($.attr(element, "tabindex")));
    },
 
    tabbable: function(element) {
      var tabIndex = $.attr(element, "tabindex"),
        isTabIndexNaN = isNaN(tabIndex);
      return (isTabIndexNaN || tabIndex >= 0) && focusable(element, !isTabIndexNaN);
    }
  });
 
  // Create a jQuery extension to sort elements in tab order.
  $.fn.sortByTabindex = function() {
    var toStart, toEnd, $sorted;
 
    function compare(a, b) {
      var tabindexA = parseInt($(a).attr('tabindex'), 10),
        tabindexB = parseInt($(b).attr('tabindex'), 10);
      // Treat no tabindex and tabindex=-1
      // the same as tabindex=0, if they should follow DOM order
      if (isNaN(tabindexA) || tabindexA === -1) {
        tabindexA = 0;
      }
      if (isNaN(tabindexB) || tabindexB === -1) {
        tabindexB = 0;
      }
      if (tabindexA === tabindexB) {
        return 0;
      }
      if (tabindexA < tabindexB) {
        return -1;
      }
      if (tabindexA > tabindexB) {
        return 1;
      }
    }
    // sort the elements
    $sorted = $(this).sort(compare);
    // elements with no tabindex, tabindex=0 or tabindex=-1 should move to end of sort order
    toEnd = $sorted.filter(':not([tabindex]), [tabindex=0], [tabindex=-1]').toArray();
    // elements with a positive tabindex should move to start of sort order
    toStart = $sorted.filter('[tabindex]').not('[tabindex=0], [tabindex=-1]').toArray();
    // concatenate arrays in tab order.
    $sorted = $(toStart.concat(toEnd))
    return $sorted;
  };
 
  // listen for "focusout" event within the .cp-movie context and restore focus to next element if no element has focus
  $(".cp-movie").bind("focusout", function(e) {
    var $target = $(e.target),
      $currentTarget = $(e.currentTarget),
      data = e.data || "",
      $sorted = $currentTarget.find(data + " :tabbable").add(e.target).sortByTabindex(),
      index = $sorted.index(e.target),
      $next = $sorted.filter(":gt(" + index + "):first"),
      addedFilter = ":last";
    if (!$next.length) {
      if ($target.is(":not([tabindex]), [tabindex=0], [tabindex=-1]")) {
        addedFilter = ":first";
      }
      $next = $sorted.filter(":lt(" + index + ")" + addedFilter);
    }
    setTimeout(function() {
      if (!$target.is(":tabbable") && $(document.activeElement).not("body").filter(":focusable").length === 0) {
        $next.focus();
      }
    }, 0);
  });
}